<?php

/**
 * Form constructor for the shib_auth_form admin page.
 */
function shib_auth_form_admin($form, &$form_state) {
  $form = array();

  $form['shib_auth_xml_metadata'] = array(
    '#type' => 'fieldset',
    '#title' => t('XML metadata'),
    '#weight' => 0,
    '#collapsible' => FALSE,
  );

  $form['shib_auth_xml_metadata']['shib_auth_xml_metadata_url'] = array(
    '#type' => 'textfield',
    '#title' => t("XML metadata URL"),
    '#default_value' => variable_get('shib_auth_xml_metadata_url'),
    '#required' => TRUE,
  );

  if (_shib_auth_form_xml_metadata_check()) {
    $form['shib_auth_xml_metadata']['ipds'] = array(
      '#type' => 'fieldset',
      '#title' => t('Institutions'),
      '#weight' => 1,
      '#collapsible' => FALSE,
    );

    $count_idps = count(_shib_auth_xml_metadata_idps());
    $idps_info = ($count_idps > 0) ? format_plural($count_idps, t('1 institution found for the given XML.'), t('@count institutions found for the given XML.')) : t('No institution was found for the given XML.');

    $form['shib_auth_xml_metadata']['ipds']['info'] = array(
      '#type' => 'item',
      '#markup' => $idps_info,
    );

    $form['shib_auth_xml_metadata']['ipds']['scan'] = array(
      '#type' => 'submit',
      '#value' => t('Rescan XML metadata'),
    );
  }

  // Triggers the action to "Rescan institutions".
  $form['#submit'] = array('shib_auth_form_rescan_idps');

  return system_settings_form($form);
}

/**
 * Triggers to "Rescan institutions".
 */
function shib_auth_form_rescan_idps($form, &$form_state) {
  _shib_auth_xml_metadata_idps(TRUE);

  drupal_set_message(t('The list of institutions has been updated.'), 'status');
}
